// -*- c++ -*-
dnl   GTK-- - a C++ wrapper for the Gtk toolkit
dnl  
dnl   The signal system used by gtk--
dnl  
dnl   This file has handling of plain signals - this should be
dnl   independent of gtk, but it currently isnt.
dnl   
dnl   Copyright (C) 1997 Elliot Lee <sopwith@redhat.com>      
dnl                      Phil Dawes
dnl                      Tero Pulkkinen
dnl
dnl   Copyright 1998, Karl Nelson
dnl  
dnl   Currently maintained by Tero Pulkkinen. <terop@modeemi.cs.tut.fi>
dnl                                                          
dnl   This library is free software; you can redistribute it and/or
dnl   modify it under the terms of the GNU Library General Public
dnl   License as published by the Free Software Foundation; either
dnl   version 2 of the License, or (at your option) any later version.
dnl  
dnl   This library is distributed in the hope that it will be useful,
dnl   but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl   Library General Public License for more details.
dnl  
dnl   You should have received a copy of the GNU Library General Public
dnl   License along with this library; if not, write to the Free
dnl   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
dnl   
dnl Ignore the next line
/* This is a generated file, do not edit.  Generated from gtk--sigcpp.h.m4 */
#ifndef GTKMM_SIGCPP
#define GTKMM_SIGCPP
#include <gtk--sigcommon.h>

include(gtk--sig.macros.m4)

/*************************************************************/
/* Tero's signal implementation starts from here.            */
/* This makes some additions to Phil's slot stuffs           */
/* Now it is possible for a C++ programmer to create signals */
/*************************************************************/

/*signals_impl*/
dnl
dnl SIGNALS_IMPL([P1, P2, ...],returntype)
dnl   returntype = _r 
define([SIGNALS_IMPL],
[/********************************************************************
*****  Signals with NUM($1) Arguments IF($2,with return type)
********************************************************************/
IF([$1$2],[template<LIST(class rettype,$2,ARG_CLASS($1),1)>]) 
  class [Abstractslot]NUM($1)[$2] : public Connection_impl 
    { 
     public: 
       virtual IF($2,rettype,void) call(ARG_BOTH($1))=0; 
    }; 

IF([$1$2],[template<LIST(class rettype,$2,ARG_CLASS($1),1)>])
  class [Signal]NUM($1)[$2] 
    { 
       ConnImpl_List connectionlist; 
     public: 
       Connection_impl *begin() { return connectionlist.begin(); }
       Connection_impl *end() { return connectionlist.end(); }
       void insert_connection(Connection_impl *slot) 
dnl [Abstractslot]NUM($1)[$2] T_DROP(<LIST(rettype,$2,ARG_TYPE($1),1)>) *slot) 
         { 
          connectionlist.insert(slot); 
         } 
       IF($2,rettype,void) operator()(ARG_BOTH($1)) 
         {IF($2,rettype rval;) 
          Connection_impl *c=connectionlist.begin(); 
          Connection_impl *tmp;
          while(c!=connectionlist.end()) 
            { 
             tmp=c->next;
             IF($2,rval=)(([Abstractslot]NUM($1)[$2] T_DROP(<LIST(rettype,$2,ARG_TYPE($1),1)>)*)c)->call(ARG_NAME($1)); 
             c=tmp; 
            } 
          IF($2,return rval;)
         } 
    }; 

])

/*cm_signal_impl*/
define([CM_SIGNAL_IMPL],
[/**** connect_to_method IF($2,with data) IF($3,wigh return) ****/
template<LIST(class rettype,$3,class T,1,ARG_CLASS($1),1,class E,$2)>
  class [Concretecppslot]NUM($1)[$2][$3] : public [Abstractslot]NUM($1)[$3] T_DROP(<LIST(rettype,$3,ARG_TYPE($1),1)>)
  {
   private:
     T* obj;
     IF($3,rettype,void) (T::*method)(LIST(ARG_TYPE($1),1,E,$2));
     IF($2,E cbdata;)
   public:
     [Concretecppslot]NUM($1)[$2][$3](T* receiver, IF($3,rettype,void) (T::*met)(LIST(ARG_TYPE($1),1,E,$2)) IF($2,[,E cbd]) )
       : obj(receiver), method(met) IF($2,[,cbdata(cbd)]) {}
     IF($3,rettype,void) call(ARG_BOTH($1)) 
       { IF($3,return) (obj->*method)(LIST(ARG_NAME($1),1,cbdata,$2)); 
       }
   };

template<LIST(class rettype,$3,[class T,class T1],1,ARG_CLASS($1),1,class E,$2)>
  Connection connect_to_method(
    [Signal]NUM($1)[$3]T_DROP(<LIST(rettype,$3,ARG_TYPE($1),1)>) &signal,
    T* receiver,IF($3,rettype,void) (T1::*method)(LIST(ARG_TYPE($1),1,E,$2)) IF($2,[,E cbd]))
  {
   Connection_impl *slot=
     new [Concretecppslot]NUM($1)[$2][$3]<LIST(rettype,$3,T,1,ARG_TYPE($1),1,E,$2)>(receiver,method IF($2,[,cbd]));
   signal.insert_connection(slot);
   receiver->insert_connection(slot);
   return Connection(slot);
  }

])

/*cf_signal_impl*/
define([CF_SIGNAL_IMPL],
[/**** connect_to_function IF($2,with data) IF($3,with return) ****/
template<LIST(class rettype,$3,class M,1,ARG_CLASS($1),1,class E,$2)>
class [Concretegtkslot]NUM($1)[$2][$3] : public [Abstractslot]NUM($1)[$3] T_DROP(<LIST(rettype,$3,ARG_TYPE($1),1)>)
  {
   private:
     M func;
     IF($2,E cbdata;)
   public:
     [Concretegtkslot]NUM($1)[$2][$3](M func_ IF($2,[,E cbd]))
       : func(func_) IF($2,[,cbdata(cbd)]) {}
     IF($3,rettype,void) call(ARG_BOTH($1))
       { IF($3,return) func(LIST(ARG_NAME($1),1,cbdata,$2)); }
     static IF($3,rettype,void) callback(GtkWidget * C_ARG_BOTH($1),
       [Concretegtkslot]NUM($1)[$2][$3]<LIST(rettype,$3,M,1,ARG_TYPE($1),1,E,$2)>* s)
       { IF($3,return GTKMM_PROXY_RV_HACK) s->call(ARG_NAME($1)); }
  };

IF([$1$2$3],[template<LIST(class rettype,$3,ARG_CLASS($1),1,class E,$2)>])
inline Connection connect_to_function(
    [Signal]NUM($1)[$3] T_DROP(<LIST(rettype,$3,ARG_TYPE($1),1)>) &signal,
    IF($3,rettype,void) (*func)(LIST(ARG_TYPE($1),1,E,$2)) IF($2,[,E cbd]))
  {
   Connection_impl *slot=
     new [Concretegtkslot]NUM($1)[$2][$3]<LIST(rettype,$3,PROT(IF($3,rettype,void) (*)(LIST(ARG_TYPE($1),1,E,$2))),1,ARG_TYPE($1),1,E,$2)>(func IF($2,[,cbd]));
   signal.insert_connection(slot);
   return Connection(slot);
  }

])

/*cs_signal_impl*/
define([CS_SIGNAL_IMPL],
[/**** connect_to_signal IF($2,with data) IF($3,with return) ****/
template<LIST(class rettype,$3,class M,1,ARG_CLASS($1),1,class E,$2)>
  Connection connect_to_signal(
    [Signal]NUM($1)[$3] T_DROP(<LIST(rettype,$3,ARG_TYPE($1),1)>) &signal,
    M& func IF($2,[,E cbd]) )
  {
   Connection_impl *slot=
     new [Concretegtkslot]NUM($1)[$2][$3]<LIST(rettype,$3,M&,1,ARG_TYPE($1),1,E,$2)>(func IF($2,[,cbd]));
   signal.insert_connection(slot);
   return Connection(slot);
  }

])

define([SIGNALS],
[
SIGNALS_IMPL([$1])
CM_SIGNAL_IMPL([$1],,)
CM_SIGNAL_IMPL([$1],cb,)
CF_SIGNAL_IMPL([$1],,)
CF_SIGNAL_IMPL([$1],cb,)
CS_SIGNAL_IMPL([$1],,)
CS_SIGNAL_IMPL([$1],cb,)

SIGNALS_IMPL([$1],_r)
CM_SIGNAL_IMPL([$1],,_r)
CM_SIGNAL_IMPL([$1],cb,_r)
CF_SIGNAL_IMPL([$1],,_r)
CF_SIGNAL_IMPL([$1],cb,_r)
CS_SIGNAL_IMPL([$1],,_r)
CS_SIGNAL_IMPL([$1],cb,_r)

])

SIGNALS([])
SIGNALS([P1])
SIGNALS([P1,P2])
SIGNALS([P1,P2,P3])
SIGNALS([P1,P2,P3,P4])
SIGNALS([P1,P2,P3,P4,P5])
SIGNALS([P1,P2,P3,P4,P5,P6])


#endif
