// -*- c++ -*-
dnl   GTK-- - a C++ wrapper for the Gtk toolkit
dnl  
dnl   The signal system used by gtk--
dnl  
dnl   This file has handling of plain signals - this should be
dnl   independent of gtk, but it currently isnt.
dnl   
dnl   Copyright (C) 1997 Elliot Lee <sopwith@redhat.com>      
dnl                      Phil Dawes
dnl                      Tero Pulkkinen
dnl  
dnl   Copyright (C) 1998 Karl Nelson
dnl  
dnl   Currently maintained by Tero Pulkkinen. <terop@modeemi.cs.tut.fi>
dnl                                                          
dnl   This library is free software; you can redistribute it and/or
dnl   modify it under the terms of the GNU Library General Public
dnl   License as published by the Free Software Foundation; either
dnl   version 2 of the License, or (at your option) any later version.
dnl  
dnl   This library is distributed in the hope that it will be useful,
dnl   but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl   Library General Public License for more details.
dnl  
dnl   You should have received a copy of the GNU Library General Public
dnl   License along with this library; if not, write to the Free
dnl   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
dnl   
dnl Ignore the next line
/* This is a generated file do not edit.  Generated from gtk--sigproxy.h.m4 */
#ifndef GTKMM_SIGPROXY
#define GTKMM_SIGPROXY

#include <gtk/gtksignal.h>
#include <gtk/gtkwidget.h>

#include <gtk--sigcommon.h>
#include <gtk--sigslot.h>
#include <gtk--sigcpp.h>
class Gtk_Object;

include(gtk--sig.macros.m4)

class Signal_proxy_base 
  {
   public:
     const gchar *signal_name;
     Gtk_Object *sender;
     Signal_proxy_base(const gchar *sign,Gtk_Object *send) 
       : signal_name(sign), sender(send) {}
  };

/* signal_proxy_imp */
dnl
dnl  SIGNAL_PROXY_IMP([P1,P2,...],rettype)
define([SIGNAL_PROXY_IMP],
[/********************************************************************
*****  Signal_Proxy with LIST(NUM($1) Arguments,1,return type, $2)
********************************************************************/
template<LIST(class rettype,$2,[class GtkObjType],1,ARG_CLASS($1),1)>
  class [Signal_proxy]NUM($1)[$2] : public Signal_proxy_base
  {  IF($2,rettype,void) (*func)(GtkObjType* C_ARG_TYPE($1));
   public:
     [Signal_proxy]NUM($1)[$2] (const gchar *name, Gtk_Object *obj,
        IF($2,rettype,void) (*func_)(GtkObjType* C_ARG_TYPE($1))=0); 
     IF($2,rettype,void) operator()(ARG_BOTH($1));
  };

template<LIST(class rettype,$2,[class GtkObjType],1,ARG_CLASS($1),1)>
  IF($2,rettype,void) [Signal_proxy]NUM($1)[$2] <LIST(rettype,$2,[GtkObjType],1,ARG_TYPE($1),1)>::operator()(ARG_BOTH($1))
  {IF($2,rettype rval;,int rval;)
   if (func) 
      IF($2,rval=)func((GtkObjType*)sender->gtkobj() C_ARG_NAME($1)); 
    else 
      gtk_signal_emit_by_name(sender->gtkobj(),signal_name C_ARG_NAME($1),&rval); 
   IF($2,return rval;)
  }

template<LIST(class rettype,$2,[class GtkObjType],1,ARG_CLASS($1),1)>
  [Signal_proxy]NUM($1)[$2] <LIST(rettype,$2,[GtkObjType],1,ARG_TYPE($1),1)>::[Signal_proxy]NUM($1)[$2]
    (const gchar *name, Gtk_Object *obj, IF($2,rettype,void) (*func_)(GtkObjType* C_ARG_TYPE($1)))
    : Signal_proxy_base(name,obj), func(func_)
  {}

])

/* cm_signal_proxy_imp */
dnl
dnl  CM_SIGNAL_PROXY_IMP([P1,P2,...],cbdata,rettype)
define([CM_SIGNAL_PROXY_IMP],
[/*** connect_to_method LIST(NUM($1) args,1, cbdata,$2, return type,$3) ***/
template<LIST(class rettype,$3,[class GtkObjType,class T],1,ARG_CLASS($1),1,class E,$2)>
  Connection connect_to_method(
    [Signal_proxy]NUM($1)[$3] <LIST(rettype,$3,[GtkObjType],1,ARG_TYPE($1),1)> &proxy,
    T *receiver,IF($3,rettype,void) (T::*method)(LIST(ARG_TYPE($1),1,E,$2)) IF($2,[,E arg]) )
  {Connection_impl* slot = 
     new [Slot]NUM($1)[$2][$3]<LIST(rettype,$3,T,1,ARG_TYPE($1),1,E,$2)>(receiver,method IF($2,[,arg]));
   proxy.sender->insert_connection(slot);
   gint conn;
   conn=gtk_signal_connect(GTK_OBJECT(proxy.sender->gtkobj()), const_cast<gchar*>(proxy.signal_name), 
     GtkSignalFunc([Slot]NUM($1)[$2][$3]<LIST(rettype,$3,T,1,ARG_TYPE($1),1,E,$2)>::callback),slot);
   slot->setgtkconnection(proxy.sender->gtkobj(),conn);
   return Connection(slot);
  }

])

/* cf_signal_proxy_imp */
dnl
dnl  CF_SIGNAL_PROXY_IMP([P1,P2,...],cbdata,rettype)
define([CF_SIGNAL_PROXY_IMP],
[/*** connect_to_function LIST(NUM($1) args,1, cbdata,$2, return type,$3) ***/
template<LIST(class rettype,$3,[class GtkObjType],1,ARG_CLASS($1),1,class E,$2)>
  Connection connect_to_function(
    [Signal_proxy]NUM($1)[$3] <LIST(rettype,$3,[GtkObjType],1,ARG_TYPE($1),1)> &proxy, 
    IF($3,rettype,void) (*method)(LIST(ARG_TYPE($1),1,E,$2)) IF($2,[,E arg]))
  { Connection_impl* slot=
      new [Concretegtkslot]NUM($1)[$2][$3]<LIST(rettype,$3,
        PROT(IF($3,rettype,void) (*)(LIST(ARG_TYPE($1),1,E,$2))),1,ARG_TYPE($1),1,E,$2)>(method IF($2,[,arg]));
   proxy.sender->insert_connection(slot);
   gint conn;
   conn=gtk_signal_connect(GTK_OBJECT(proxy.sender->gtkobj()),const_cast<gchar*>(proxy.signal_name), 
     GtkSignalFunc([Concretegtkslot]NUM($1)[$2][$3]<LIST(rettype,$3,PROT(IF($3,rettype,void) (*)(LIST(ARG_TYPE($1),1,E,$2))),1,ARG_TYPE($1),1,E,$2)>::callback),slot);
   slot->setgtkconnection(proxy.sender->gtkobj(),conn);
   return Connection(slot);
  }

])

/* cs_signal_proxy_imp */
dnl
dnl  CS_SIGNAL_PROXY_IMP([P1,P2,...],cbdata)
define([CS_SIGNAL_PROXY_IMP],
[/*** connect_to_signal LIST(NUM($1) args,1, cbdata,$2, return type,$3) ***/
template<LIST(class rettype,$3,[class GtkObjType,class M],1,ARG_CLASS($1),1,class E,$2)>
  Connection connect_to_signal(
    [Signal_proxy]NUM($1)[$3] <LIST(rettype,$3,[GtkObjType],1,ARG_TYPE($1),1)> &proxy,
    M &func IF($2,[,E arg]))
  { Connection_impl* slot = 
      new [Concretegtkslot]NUM($1)[$2][$3]<LIST(rettype,$3,M&,1,ARG_TYPE($1),1,E,$2)>(func IF($2,[,arg]));
    proxy.sender->insert_connection(slot);
    gint conn;
    conn=gtk_signal_connect(GTK_OBJECT(proxy.sender->gtkobj()),proxy.signal_name, 
      GtkSignalFunc([Concretegtkslot]NUM($1)[$2][$3]<LIST(rettype,$3,M&,1,ARG_TYPE($1),1,E,$2)>::callback),slot);
    slot->setgtkconnection(proxy.sender->gtkobj(),conn);
    return Connection(slot);
  }

])

define([PROXY_IMP],
[
SIGNAL_PROXY_IMP([$1],)
CM_SIGNAL_PROXY_IMP([$1],,)
CM_SIGNAL_PROXY_IMP([$1],cb,)
CF_SIGNAL_PROXY_IMP([$1],,)
CF_SIGNAL_PROXY_IMP([$1],cb,)
CS_SIGNAL_PROXY_IMP([$1],,)
CS_SIGNAL_PROXY_IMP([$1],cb,)
SIGNAL_PROXY_IMP([$1],_r)
CM_SIGNAL_PROXY_IMP([$1],,_r)
CM_SIGNAL_PROXY_IMP([$1],cb,_r)
CF_SIGNAL_PROXY_IMP([$1],,_r)
CF_SIGNAL_PROXY_IMP([$1],cb,_r)
CS_SIGNAL_PROXY_IMP([$1],,_r)
CS_SIGNAL_PROXY_IMP([$1],cb,_r)
])

PROXY_IMP()
PROXY_IMP([P1])
PROXY_IMP([P1,P2])
PROXY_IMP([P1,P2,P3])
PROXY_IMP([P1,P2,P3,P4])
PROXY_IMP([P1,P2,P3,P4,P5])
PROXY_IMP([P1,P2,P3,P4,P5,P6])

#endif

